// person definition for family tree
// hussein suleman
// 13 april 2009

public class Person
{
   String name;                        // name of person
   Person spouse;                      // reference to spouse object
   Person child1, child2, child3;      // references to children

   // constructor to set name of person
   public Person ( String aName )
   {
      name = aName;
   }
   
   // accessor to get name of person
   public String getName ()
   {
      return name;
   }
   
   // mutator to set reference to spouse's object
   public void setSpouse ( Person otherHalf )
   {
      spouse = otherHalf;
   }
   
   // mutator to set references to children's objects
   public void setChildren ( Person c1, Person c2, Person c3 )
   {
      child1 = c1;
      child2 = c2;
      child3 = c3;
   }
      
   // print out family tree for current person and all descendents
   public String toString ()
   {
      // in children references exist, get their family trees
      String child1Family = "";
      String child2Family = "";
      String child3Family = "";
      if (child1 != null)
         child1Family = child1.toString();
      if (child2 != null)
         child2Family = child2.toString();
      if (child3 != null)
         child3Family = child3.toString();
			
      // if spouse exists, get his/her name
      String spouseName = "";
      if (spouse != null)
         spouseName = spouse.getName ();
         
      // assemble name, spouse's name and children's subtrees into a tree 
      return name + " (" + spouseName + ")" + 
             "\n" + child1Family + 
             "\n" + child2Family + 
             "\n" + child3Family;
   }

// Exercise: can you make it print out this "prettier" version ("pretty" is a technical term in
// output formatting) ?
//
//don corleone (don's wife)
// michael
// sonny
// jane (antonio)
//  leonardo
//  mario

}

